// Transformacoes1.cpp : Defines the entry point for the console application.
//
#include <windows.h>
#include <GL\gl.h>
#include <GL\glut.h>


#define OP_ROTACAO		1
#define OP_TRANSLACCAO	2
#define OP_ESCALA		3
#define OP_ROT_TRANS	4
#define OP_TRANS_ROT	5

int op;

void drawAxis()
{
#define AXIS_LIMIT	4

	GLfloat mat_r[] = {1.0, 0.0, 0.0, 1.0};
	GLfloat mat_g[] = {0.0, 1.0, 0.0, 1.0};
	GLfloat mat_b[] = {0.0, 0.0, 1.0, 1.0};

	glPushAttrib(GL_LINE_BIT);
	//glLineWidth(2.0);
	glBegin(GL_LINES);
		// XX
		glColor4fv(mat_r);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_r);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(-AXIS_LIMIT, 0, 0);
		glVertex3f(+AXIS_LIMIT, 0, 0);

		// YY
		glColor4fv(mat_g);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_g);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, -AXIS_LIMIT, 0);
		glVertex3f(0, +AXIS_LIMIT, 0);

		// ZZ
		glColor4fv(mat_b);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_b);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, 0, -AXIS_LIMIT);
		glVertex3f(0, 0, +AXIS_LIMIT);
	glEnd();
	glPopAttrib();
}

void display()
{
	GLfloat mat_obj[] = {0.6, 0.6, 0.6, 1.0};

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 0, 5, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

	// eixo global
	drawAxis();

	// transformaes
	switch (op)
	{
	case OP_ROTACAO:
		glRotatef(45, 0, 0, 1);
		break;
	case OP_TRANSLACCAO:
		glTranslatef(2, 0, 0);
		break;
	case OP_ESCALA:
		glScalef(.5, .5, .5);
		break;
	case OP_ROT_TRANS:
		glRotatef(45, 0, 0, 1);
		glTranslatef(2, 0, 0);
		break;
	case OP_TRANS_ROT:
		glTranslatef(2, 0, 0);
		glRotatef(45, 0, 0, 1);
		break;
	}

	// desenhar modelo
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_obj);
	glutSolidCube(1.5);

	glFlush ();
}

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glOrtho(-3.0, 3.0, -3.0, 3.0, 0.1, 20.0);
	gluPerspective(60, 1, 1, 10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 0, 5, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}


void keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27:
		exit(0);
		break;
	case 's':
	case 'S':
		op = OP_ESCALA;
		break;
	case 't':
	case 'T':
		op = OP_TRANSLACCAO;
		break;
	case 'r':
	case 'R':
		op = OP_ROTACAO;
		break;
	case '1':
		op = OP_ROT_TRANS;
		break;
	case '2':
		op = OP_TRANS_ROT;
		break;
	}
	glutPostRedisplay();
}

void init()
{
  glFrontFace(GL_CW);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
}

int main(int argc, CHAR* argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize (250, 250);
	glutInitWindowPosition (100, 100);
	glutCreateWindow ("Transformacoes");
	init ();
	glutKeyboardFunc(keyboard);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMainLoop();

	return 0;
}

